# NVDA Quick Dictionary (Быстрый словарь)

* Автор: Олександр Грищенко
* Версия: 2.1
* Совместимость с NVDA: 2019.3 и более новые версии
* Скачать [стабильную версию][1]

Слава Украине! Героям слава!!!

Добро пожаловать в дополнение NVDA Quick Dictionary, которое позволит вам быстро получить словарную статью с переводом слова или словосочетания на выбранный язык при помощи комбинации клавиш. Основных клавишных команд немного и все они интуитивно понятны и удобны поэтому вы быстро их запомните.

Словарные статьи содержат подробную информацию о слове, такую как часть речи, род, число, варианты перевода, перечень значений, синонимы и подробные примеры. Такая информация будет полезной для людей, изучающих иностранные языки, или стремящихся использовать в общении все богатство и разнообразие собственного языка.

Дополнение поддерживает несколько сервисов онлайн словарей. Вы можете выбрать нужный удаленный словарь в соответствующем диалоговом окне или воспользовавшись клавишными командами. Каждый доступный сервис имеет собственную панель настроек.

Также присутствуют расширенные функции для работы с профилями голосовых синтезаторов. Вы можете связать профиль синтезатора голоса с определенным языком, после чего переводы на этот язык будут автоматически озвучиваться выбранным синтезатором.

Ниже приведены все возможности дополнения и сочетания клавиш для управления ими. По умолчанию все функции вызываются с использованием двухуровневых команд. Но для любого из этих методов вы всегда можете назначить удобные для вас сочетания клавиш. Вы можете сделать это в диалоговом окне NVDA "Параметры" -> "Жесты ввода...".

## Получение словарной статьи
Для того, чтобы получить статью из словаря необходимо сначала выделить слово, которое Вас интересует или скопировать его в буфер обмена. После чего достаточно дважды нажать комбинацию клавиш NVDA+Y.

Существует также другая возможность получения записи из словаря: одноразовое нажатие NVDA+Y переключает клавиатуру в режим управления дополнением, а дальше просто воспользуйтесь клавишей D.

## Режим управления дополнением
Для доступа ко всем функциям дополнения нужно переключиться в режим управления дополнением, это можно сделать нажав однократно NVDA+Y. Вы услышите низкий звуковой сигнал и сможете воспользоваться другими клавишными командами, которые будут описаны ниже. При нажатии клавиши, которая не используется в дополнении, вы услышите другой сигнал, который сообщит об ошибочной команде и режим управления дополнением будет автоматически выключен.

## Перечень всех функций дополнения
Основные словарные команды:

* D - объявить словарную статью для выделенного слова или словосочетания (то же, что NVDA+Y);
* W - показать словарную статью в отдельном окне для просмотра;
* S - изменить порядок языков и получить быстрый перевод;
* A - объявить текущие исходный и целевой языки;
* C - скопировать результаты последнего запроса в буфер обмена;
* E - редактировать текст перед отправкой;
* U - скачать из онлайн-словаря и сохранить актуальный список доступных языков;
* функциональные клавиши - выбор службы онлайн-словарей;
* Q - статистика использования текущего удаленного сервиса;
* F - выбор онлайн-сервиса.

Управление профилями голосовых синтезаторов:

* от 1 до 9 - выбор профиля голосового синтезатора;
* G - объявить выбранный профиль голосовых синтезаторов;
* B - вернуться к предыдущему голосовому синтезатору;
* R - вернуться к голосовому синтезатору по умолчанию;
* Del - удалить выбранный профиль голосового синтезатора;
* V - сохранить текущий настроенный профиль синтезатора голоса;
* P - отобразить список настроенных профилей голосовых синтезаторов.

Нажмите O чтобы открыть диалог настроек дополнения.

## Справка по командам дополнения
Ознакомиться со списком всех команд, используемых в дополнении можно следующим образом:

* Через меню NVDA - нажав NVDA+N, перейти к подменю "Сервис", далее - "Быстрый словарь" и активировать пункт меню "Справка по командам дополнения".
* Нажать клавишу H в режиме управления дополнением (NVDA+Y).

## Справка
Чтобы открыть справку по дополнению - нажмите NVDA+N, перейдите в подменю "Сервис", далее - "Быстрый словарь" и активируйте пункт меню "Справка".

## Благодарности
Мы очень благодарны всем, кто прикладывает усилия в разработке, переводе и поддержке дополнения:

* Cagri Dogan - перевод на турецкий язык;
* Wafiqtaher - перевод на арабский язык.

В дополнении Quick Dictionary было использовано несколько хороших решений из других разработок. Благодарим авторов следующих дополнений:

* Instant Translate - Alexy Sadovoy, Beqa Gozalishvili, Mesar Hameed, Alberto Buffolino и другие соавторы.
* Для работы с профилями синтезаторов голоса были использованы идеи из дополнения Switch Synth (автор Tyler Spivey).

## Журнал изменений

### Версия 2.1.5
* дополнение протестировано на совместимость с NVDA 2022.1;
* исходный код значительно оптимизирован и добавлены MyPy подсказки типов;
* дополнение адаптировано для поддержки Python версий 3.7 и 3.8;
* исправлены ошибки форматирования в Markdown-файлах;
* добавлено диалоговое окно для редактирования текста перед отправкой его на удаленный сервис;
* отделена справка дополнения от ReadMe;
* обновлен перевод на турецкий язык (благодарность Cagri Dogan).

## Внесение изменений в NVDA QuickDictionary
Вы можете клонировать этот репозиторий, чтобы внести изменения в NVDA Quick Dictionary.

### Сторонние зависимости
Следующие модули могут быть установлены при помощи pip:

- markdown
- scons
- python-gettext

### Упаковка дополнения для распространения
1. Откройте командную строку, перейдите в корневой каталог этого репозитория.
2. Запустите команду **scons**. Созданное дополнение при отсутствии ошибок будет помещено в текущий каталог.

[1]: https://addons.nvda-project.org/files/get.php?file=quickdictionary
