# NVDA Quick Dictionary (Швидкий словник)

* Автор: Олександр Грищенко
* Версія: 2.2
* Сумісність з NVDA: 2019.3 та новіші версії
* Завантажити [стабільну версію][1]

Ласкаво просимо до додатку NVDA Quick Dictionary, котрий дозволить вам швидко отримати словникову статтю з перекладом слова або словосполучення на обрану мову за допомогою натискання комбінації клавіш. Основних комбінацій клавіш небагато і всі вони інтуітивно зрозумілі та зручні тому Ви швидко їх запам'ятаєте.

Словникові статті містять докладну інформацію про слово, таку як частина мови, рід, множина чи однина, варіанти перекладу, перелік значень, синоніми та детальні приклади. Така інформація буде корисною для людей, які вивчають іноземні мови, або прагнуть використовувати у спілкуванні все багатство та різноманіття власної мови.

Додаток підтримує декілька сервісів онлайн словників. Ви можете обрати потрібний віддалений словник у відповідному діалоговому вікні або скориставшись клавішними командами. Кожен доступний сервіс має власну панель налаштувань.

Також наявні додаткові функції для роботи з профілями синтезаторів голосу. Ви можете асоціювати профіль синтезатора голосу з певною мовою, після чого переклади на цю мову будуть автоматично озвучуватись обраним синтезатором.

Нижче наведені всі можливості додатку та комбінації клавіш для керування ними. За замовчуванням всі функції викликаються за допомогою дворівневих клавішних команд. Але для будь-якого з перерахованих методів, ви завжди можете призначити зручні для вас комбінації клавіш. Це можна зробити в діалоговому вікні NVDA "Параметри" -> "Жести вводу...".

## Отримання словникової статті
Для того, щоб отримати статтю зі словника необхідно спочатку виділити слово, яке Вас цікавить або скопіювати його до буфера обміну. Після чого достатньо лише двічі натиснути комбінацію клавіш NVDA+Y.

Існує також інша можливість отримання запису зі словника: одноразове натискання NVDA+Y перемикає клавіатуру в режим керування додатком, а далі просто скористайтесь клавішою D.

## Режим керування додатком
Для доступу до всіх функцій додатку потрібно переключитись в режим керування додатком, це можна зробити натиснувши одноразово NVDA+Y. Ви почуєте короткий низький звуковий сигнал і зможете скористатись іншими командами, які буде описано нижче. При натисканні клавіші, яка не використовується у додатку, ви почуєте інший сигнал, що сповістить про помилкову команду і режим керування додатком буде автоматично вимкнений.

## Перелік всіх функцій додатку
Основні словникові команди:

* D - оголосити словникову статтю для виділеного слова або словосполучення (те саме, що NVDA+Y);
* W - показати словникову статтю в окремому вікні для перегляду;
* S - змінити порядок мов та отримати швидкий переклад;
* A - оголосити поточну мову оригіналу та мову перекладу;
* C - скопіювати результати останнього запиту до буфера обміну;
* E - редагувати текст перед відправкою;
* U - завантажити з онлайн-словника та зберегти актуальний список доступних мов;
* функціональні клавіші - вибір служби онлайн-словників;
* Q - статистика використання поточного віддаленого сервісу;
* F - вибір онлайн-сервісу.

Керування профілями голосових синтезаторів:

* від 1 до 9 - вибір профіля голосового синтезатора;
* G - оголосити вибраний профіль голосових синтезаторів;
* B - повернутись до попереднього синтезатора голосу;
* R - повернутись до голосового синтезатора за замовчуванням;
* Del - видалити вибраний профіль голосового синтезатора;
* V - зберегти налаштований профіль синтезатора голосу;
* P - відобразити список усіх налаштованих профілів синтезаторів голосу.

Натисніть O щоб відкрити діалог налаштувань додатку.

## Довідка по командах додатку
Ознайомитись зі списком всіх команд, що використовуються в додатку можна наступним чином:

* Через меню NVDA - натиснувши NVDA+N, перейти до підменю "Інструменти", далі - "Швидкий словник" і активувати пункт меню "Довідка по командах додатку".
* Натиснути клавішу H в режимі керування додатком (NVDA+Y).

## Довідка
Щоб відкрити довідку по додатку - натисніть NVDA+N, перейдіть до підменю "Інструменти", далі - "Швидкий словник" і активуйте пункт меню "Довідка".

## Подяки
Ми дуже вдячні всім, хто докладає зусиль в розробці, перекладі та підтримці додатку:

* Cagri Dogan - переклад на турецьку мову;
* Wafiqtaher - переклад на арабську мову.

При розробці додатку Quick Dictionary було використано кілька хороших рішень з інших проектів. Дякуємо авторам таких додатків:

* Instant Translate - Alexy Sadovoy, Beqa Gozalishvili, Mesar Hameed, Alberto Buffolino та інші співавтори.
* Для роботи з профілями синтезаторів голосу були використані ідеї з додатку Switch Synth (автор Tyler Spivey).

## Журнал змін

### Версія 2.2
* додаток протестовано на сумісність з NVDA 2023.1;
* виправлено взаємодію з новим API сервісу Lexicala.

### Версія 2.1.5
* додаток протестовано на сумісність з NVDA 2022.1;
* вихідний код значно оптимізовано та додані MyPy підказки типів;
* додаток адаптовано для підтримки Python версій 3.7 та 3.8;
* виправлені помилки форматування у Markdown-файлах;
* додано діалогове вікно для редагування тексту перед відправкою його до віддаленого сервісу;
* відокремлено довідку додатку від ReadMe;
* оновлено переклад на турецьку мову (подяка Cagri Dogan).

## Внесення змін до NVDA Quick Dictionary
Ви можете клонувати репозиторій проекту, щоб внести зміни до вихідного коду.

### Залежності
Наступні модулі можуть бути встановлені за допомогою pip:

- markdown
- scons
- python-gettext

### Побудова додатку з вихідних кодів
1. Відкрийте командний рядок та перейдіть до кореневого каталогу репозиторію проекту.
2. Запустіть команду **scons**. Створений додаток, якщо не виникне помилок, буде розміщений в поточному каталозі.

[1]: https://addons.nvda-project.org/files/get.php?file=quickdictionary
